<id>anti:spam</id>

<version>
1.1
</version>

<edit file>
$sourcedir/Post.php
</edit file>

<search for>
			if ($func['htmltrim']($_REQUEST['subject']) == '')
				$context['post_error']['no_subject'] = true;
			if ($func['htmltrim']($_REQUEST['message']) == '')
				$context['post_error']['no_message'] = true;
			if (!empty($modSettings['max_messageLength']) && $func['strlen']($_REQUEST['message']) > $modSettings['max_messageLength'])
				$context['post_error']['long_message'] = true;
</search for>

<add after>
			// Begin AntiSpam Mod
			if (!allowedTo('add_links'))
				if(!$user_info['is_guest'])
					antiSpam("member_spam");
				elseif($user_info['is_guest'])
					antiSpam("guest_spam");
			// End AntiSpam Mod
</add after>

<search for>
		$posterIsGuest = empty($row['ID_MEMBER']);

		if (!allowedTo('moderate_forum') || !$posterIsGuest)
		{
			$_POST['guestname'] = addslashes($row['posterName']);
			$_POST['email'] = addslashes($row['posterEmail']);
		}
	}
</search for>

<add after>
	// Begin AntiSpam Mod
	if(!allowedTo('add_links'))
		if(!$posterIsGuest)
		{
			$result = antiSpam2("member_spam");
			if(isset($result))
				$post_errors[]=$result;
		}
		elseif ($posterIsGuest)
		{
			$result = antiSpam2("guest_spam");
			if(isset($result))
				$post_errors[]=$result;
		}
	// End AntiSpam Mod
</add after>

<search for>
?>
</search for>

<add before>
// Begin AntiSpam Mod
function antiSpam($whoNoLink)
{
	global $context;

	if(preg_match('@(http://|https://|\[iurl=|\[url=|\[url\]|\[iurl\]|www\.|\[/url\]|\[/iurl\]|\[img\]|\[/img\])+@i',$_POST['message']))
		 $context['post_error'][$whoNoLink] = true;

}



function antiSpam2($whoNoLink)
{
	$result = false;

	if(preg_match('@(http://|https://|\[iurl=|\[url=|\[url\]|\[iurl\]|www\.|\[/url\]|\[/iurl\]|\[img\]|\[/img\])+@i',$_POST['message']))
		$result = true;
	if ($result === false)
		 $whoNoLink = null;
	return  $whoNoLink;
}
// End AntiSpam Mod
</add before>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
'announce_topic' => false,
</search for>

<add after>
// Begin AntiSpam Mod
'add_links' => false,
// End AntiSpam Mod
</add after>

<edit file>
$languagedir/Errors.english.php
</edit file>

<search for>
?>
</search for>

<add before>

// Begin AntiSpam Mod
$txt['error_guest_spam'] = 'Sorry, guests are not allowed to post links. If this link is of any importance for your posting, please register first.';
$txt['error_member_spam'] = 'Sorry, you are not allowed to post links.';
// End AntiSpam Mod
</add before>

<edit file>
$languagedir/ManagePermissions.english.php
</edit file>

<search for>
?>
</search for>

<add before>

// Begin AntiSpam Mod
$txt['permissionname_add_links'] = 'Add links to posts';
$txt['permissionhelp_add_links'] = 'This permission allows users to add links to their post.';
// End AntiSpam Mod
</add before>
